const app = getApp()
import $http from './../../API/http'
import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    startTimeYear: '', // 开始时间的年月日
    startTimeHour: '', // 开始时间的时分
    endTimeYear: '', // 结束时间的年月日
    endTimeHour: '', // 结束时间的时分
    startTime: '', // 完整的开始时间
    endTime: '', // 完整的结束时间
    Purpose: '',
    Purposes: [],
    currentPurpose: '',
    isInput: true,
    arriveAddress: [],
    defaultAddress: '',
    Companions: [],
    copyPerson: [],
    index: '',
    copyPerson: [],
    visitorPhone: '',// 主访客的手机号
    visitorCompany: '',// 访客的单位
    visitorPurpose: '', // 访客手动输入的目的
    visitorNode: '' // 访客的备注
  },
  onLoad(query) {
    console.log('onload事件触发')
    dd.setNavigationBar({
      title: '预约访客'
    });
    let startTimeYear = this.timeToStr(new Date()).yearMonthDate
    let startTimeHour = this.timeToStr(new Date()).hourMinute
    let endTimeYear = this.timeToStr(new Date()).yearMonthDate
    let endTimeHour = this.timeToStr(new Date()).hourMinute
    this.setData({
      startTimeYear: startTimeYear,
      startTimeHour: startTimeHour,
      endTimeYear: endTimeYear,
      endTimeHour: endTimeHour
    })
    this.Purpose()
    this.arriveAddress()
  },
  //本页面input输入事件
  visitorInput(event) {
    const _that = this
    switch (event.currentTarget.dataset.type) {
      case "visitorName":
        _that.store.data.visitorName = event.detail.value
        _that.update()
        break;
      case "visitorPhone":
        _that.setData({ visitorPhone: event.detail.value })
        break;
      case "visitorCompany":
        _that.setData({ visitorCompany: event.detail.value })
        break;
      case "visitorPurpose":
        _that.setData({ visitorPurpose: event.detail.value })
        break;
      case "visitorPeerName":
        console.log(_that.store.data.visitorPeer[event.currentTarget.dataset.index - 1])
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].name = event.detail.value
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].index = event.currentTarget.dataset.index

        _that.update
        break;
      case "visitorPeerPhone":
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].phone = event.detail.value
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].index = event.currentTarget.dataset.index
        _that.update
        break;
      case "visitorNode":
        _that.setData({ visitorNode: event.detail.value })
        break;
      default:

        break;
    }
  },
  // 点击通讯录选择访客 控制遮照层出
  selectVisitors(event) {
    this.setData({ index: event.target.dataset.index })
    this.store.data.selectVisitors = true
    this.update()
  },
  // 取消遮照层
  selectCancel() {
    this.store.data.selectVisitors = false
    this.update()
  },
  // 点击外部联系人
  externalContactSelect(event) {
    dd.navigateTo({ url: `./../externalContact/externalContact?index=${this.data.index}` });
  },
  // 点击手机通讯录
  phoneAddressBookSelect() {
    dd.navigateTo({ url: `./../phoneAddressBook/phoneAddressBook?index=${this.data.index}` });
  },
  // 添加同行人员
  addCompanions() {
    if (this.store.data.visitorPeer.length < 4) {
      this.store.data.visitorPeer.push({ name: '', index: '', phone: '' })
      console.log(this.store.data.visitorPeer)
      this.update()
    } else {
      dd.alert({
        content: '最多可添加四名同行人员',
        buttonText: '确定'
      })

    }

  },
  // 关闭同行访客
  closeVisitor(event) {
    this.store.data.visitorPeer.splice(event.target.dataset.index, 1)
    this.update()
  },
  // 周知人
  copyPerson() {
    const _that = this
    dd.complexChoose({
      title: "选择周知人",            //标题
      multiple: true,            //是否多选
      limitTips: "最多可选取6人",          //超过限定人数返回提示
      maxUsers: 6,            //最大可选人数
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function(res) {
        let copyPerson = []
        res.users.forEach((item, index) => {
          copyPerson.push(item)
        })
        _that.setData({
          copyPerson: copyPerson
        })
      },
      fail: function(err) {
      }
    })

  },
  // 提交预约单
  confirmAppointment() {
    let data = {
      startTime: this.data.startTimes,
      endTime: this.data.endTimes,
      visitorInfo: `${this.store.data.visitorName}:${this.data.visitorPhone}`,
      visitorCompany: this.data.visitorCompany,
      purpose: JSON.stringify(this.data.currentPurpose),
      visitorPurpose: this.data.visitorPurpose,
      visitAddress: this.data.defaultAddress,
      visitorPeer: JSON.stringify(this.store.data.visitorPeer),
      visitorNode: this.data.visitorNode
    }
    $http.$http('/admin/visitor/addRecord', data, 'post').then(res => {
      console.log(res, 66666666666)
    })
  },
  selectStartTime() {
    dd.datePicker({
      format: 'yyyy-MM-dd HH:mm',
      success: (res => {
        let time = this.timeToStr(res.date)
        this.setData({
          startTime: `${time.year}年${time.month}月${time.date}日`,
          startTimeHour: `${time.hour}:${time.minute}`,
          startTimes: res.date
        })
      })
    })
  },
  selectEndTime() {
    dd.datePicker({
      format: 'yyyy-MM-dd HH:mm',
      success: (res => {
        let time = this.timeToStr(res.date)
        this.setData({
          endTime: `${time.year}年${time.month}月${time.date}日`,
          endTimeHour: `${time.hour}:${time.minute}`,
          endTimes: res.date
        })
      })
    })

  },
  selectPurpose(event) {
    this.setData({
      currentPurpose: this.data.Purpose[event.detail.value].visitPurpose
    })
    this.isInput()
  },
  selectAddress(event) {
    this.setData({
      defaultAddress: this.data.arriveAddress[event.detail.value].address
    })

  },
  arriveAddress() {
    $http.$http('/admin/address/list', {}, 'get').then(res => {
      console.log(res, 'arriveAddress')
      let arriveAddress = []
      res.forEach((item, index) => {
        arriveAddress.push(item.address)
        if (item.isDefault == '0') {
          this.setData({ defaultAddress: item.address })
        }
      })
      if (this.data.defaultAddress == '') {
        this.setData({ defaultAddress: arriveAddress[0] })
      }
      this.setData({ arriveAddress: arriveAddress })
    })
  },
  // 来访的目的
  Purpose() {
    $http.$http('/admin/visit-purpose/list', {}, 'post').then(res => {
      console.log(res, 'Purpose')
      let Purposes = []
      res.forEach((item, index) => {
        Purposes.push(item.visitPurpose)
      })
      this.setData({
        Purpose: res,
        Purposes: Purposes,
        currentPurpose: res[0].visitPurpose,
      })
    })
  },
  timeToStr(time) {
    if(/-/.test(time)) {
      time = time.replace(/\-/g, "/")
    }
    let timeData = new Date(time)
    let year = timeData.getFullYear()
    let month = timeData.getMonth() + 1
    let date = timeData.getDate()
    let hour = timeData.getHours()
    let minute = timeData.getMinutes()
    return {
      year: year,
      month: month.toString().length > 1 ? month : '0' + month,
      date: date.toString().length > 1 ? date : '0' + date,
      hour: hour.toString().length > 1 ? hour : '0' + hour,
      minute: minute.toString().length > 1 ? minute : '0' + minute,
      yearMonthDate: `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日`,
      hourMinute: `${hour.toString().length > 1 ? hour : '0' + hour}时${minute.toString().length > 1 ? minute : '0' + minute}分`,
      allTime: `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日 ${hour.toString().length > 1 ? hour : '0' + hour}:${minute.toString().length > 1 ? minute : '0' + minute}分`
    }
  },

  isInput() {
    if (this.data.currentPurpose != '其他') {
      this.setData({
        isInput: false
      })
    }
    else {
      this.setData({
        isInput: true
      })

    }
  },
  test() {

  },
  onReady() {

  },
  onShow() {
    // 页面显示
    // 关闭遮照层
    this.store.data.selectVisitors = false
    this.update()
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onReachBottom() {
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
