const app = getApp()
import $http from './../../API/http'
Page({
  data: {
    type: '0',
    dataList: [],
    currentPage: 1,
    pageSize: 10,
    totalCount: '',
    overdue: false,
  },
  changeType(event) {
    this.setData({
      type: event.target.dataset.type,
      dataList: []
    })
    this.visitorList(this.data.type)
  },
  visitorList(type) {
    const _that = this
    let data = {
      currentPage: this.data.currentPage,
      pageSize: this.data.pageSize,
      type: type
    }
    $http.$http('/admin/visitor/getRecordList', data, 'post').then(res => {
      let dataList = res.records;
      let dataListSource = [];
      console.log(dataList.length)
      if (dataList.length > 0) {
        dataList.forEach((item, index) => {
          if (new Date(item.endTime).getTime() < new Date().getTime()) {
            item.overdue = true
          }
          else {
            item.overdue = false
          }
          if (new Date(item.endTime).getTime() - new Date(item.startTime).getTime() < 24 * 60 * 60 * 3 * 1000) {
            item.longTime = false
          }
          else {
            item.longTime = true
          }
          item.endTime = _that.timeToStr(item.endTime)
          item.startTime = _that.timeToStr(item.startTime)
          dataListSource.push(item)
        })
        dataList = dataListSource
        let totalCount = Math.ceil(parseInt(res.total) / _that.data.pageNumber)
        _that.setData({
          dataList: dataList,
          totalCount: totalCount
        })
      }
    })

  },
  timeToStr(time) {
    time = time.replace(/\-/g, "/")
    let timeData = new Date(time)
    console.log('timeData', timeData)
    let year = timeData.getFullYear()
    let month = timeData.getMonth() + 1
    let date = timeData.getDate()
    let hour = timeData.getHours()
    let minute = timeData.getMinutes()
    return {
      year: year,
      month: month.toString().length > 1 ? month : '0' + month,
      date: date.toString().length > 1 ? date : '0' + date,
      hour: hour.toString().length > 1 ? hour : '0' + hour,
      minute: minute.toString().length > 1 ? minute : '0' + minute
    }
  },
  navigatorToNext(event) {
    dd.setStorageSync({ key: 'item', data: event.target.dataset.item })
    dd.navigateTo({ url: `./../visitorsDetail/visitorsDetail` })
  },
  appointment() {
    dd.navigateTo({url:'./../reservations/reservations'});
  },
  onLoad(query) {
    dd.setNavigationBar({ title: '智能访客' });
    this.visitorList(0)
  },
  onReady() {
  },
  onShow() {
    // 页面显示
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onReachBottom() {
    let currentNum = '';
    if (this.data.currentPage < this.data.totalCount) {
      currentNum = this.data.currentPage + 1
      this.setData({
        currentPage: currentNum
      })
      this.visitorList(this.data.type)
    }
  },
  onPullDownRefresh() {
    this.setData({
      type: '0',
      dataList: [],
      currentPage: 1,
      pageSize: 10,
      totalCount: '',
      overdue: false,
    })
    this.visitorList(this.data.type)
    dd.stopPullDownRefresh()
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
